<?php

/*
+--------------------------------------------------------------------------
|   Invision Board v1.1 - vBulletin 2.2.8 - Invision Board API
|   ========================================
|   by Matthew Mecham
|   (c) 2001,2002 Invision Power Services
|   http://www.ibforums.com
|   ========================================
|   Web: http://www.ibforums.com
|   Email: phpboards@ibforums.com
|   Licence Info: phpib-licence@ibforums.com
+---------------------------------------------------------------------------
|
|   > Functions for converting vB2 data
|   > Script written by Matt Mecham
|   > Date started: 25th November 2002
|
+--------------------------------------------------------------------------
*/

//--------------------------------------------------
//
// ABOUT THIS API
// --------------
// This API is set up to enable convertor programmers
// to quicky re-use content that is centralized in the
// other libraries.
//
// $ibforums (CLASS) Contains Invision Board config info
// $std (CLASS) Contains re-usable global functions
// $SKIN (CLASS) Contains template & form HTML
// $DB (CLASS) Contains mySQL query information
// $IN (ARRAY) same as $ibforums->input / $_GET & $_POST data
//
//
// FUNCTIONS EXPECTED
// ------------------
// config_form()  Display a HTML form asking for config details
// get_host_rows() Return an array with results from various COUNT(*)
// _convert_*  Conversion routines
//--------------------------------------------------


class api_convertor
{
	// Change this section to suit you convertor module

	var $script  = 'conv_phpbb.php';
	var $version = '2.1';
	var $board   = 'phpBB2';
	var $board_copyright = 'phpBB2 is a product of and copyright <a href="http://www.phpbb.com" target="_blank">The phpBB Group</a>';
	
	var $form_fields = array( 'hb_sql_tbl_prefix', 'hb_sql_host', 'hb_sql_database', 'hb_sql_user', 'hb_sql_pass', 'per_members', 'per_topics', 'per_posts' );
	
	//------------------------------------------------------------
	// Display the configuration form, such as original board
	// SQL log in and such.
	//------------------------------------------------------------
	
	function config_form($error="")
	{
		global $DB, $std, $SKIN, $IN, $INFO, $ibforums;
		
		$ibforums->vars['hb_sql_tbl_prefix'] = $ibforums->vars['hb_sql_tbl_prefix'] == "" ? htmlspecialchars('phpbb_') : $ibforums->vars['hb_sql_tbl_prefix'];
		
		$ibforums->vars['hb_sql_host'] = $ibforums->vars['hb_sql_host'] == "" ?	'localhost' : $ibforums->vars['hb_sql_host'];
		
		//+-------------------------------
		
		$std->page_detail = "This section will enable you to configure this convertor to your preference";
		$std->page_title  = $this->board." Convertor [ Configuration ]";
		
		//+-------------------------------
		
		if ($error != "")
		{
			$SKIN->td_header[] = array( "&nbsp;"  , "100%" );
			
			$std->html .= $SKIN->start_table( "<span style='color:red'>An Error Occured</span>" );
			
			$std->html .= $SKIN->add_td_row( array( "The following error occured:<br>$error" ) );
			
			$std->html .= $SKIN->end_table();
		}
		
		//+-------------------------------
		
		$std->html .= $SKIN->start_form( array( 1 => array( 'a'     , 'configure' ),
												2 => array( 'set'   , '1'         ),
									   )      );
		
		//+-------------------------------
		
		$SKIN->td_header[] = array( "&nbsp;"  , "40%" );
		$SKIN->td_header[] = array( "&nbsp;"  , "60%" );
		
		//+-------------------------------
		
		$std->html .= $SKIN->start_table( "Configuation" );
		
		//-----------------------------------------------------------------------------------------------------------
		
		$std->html .= $SKIN->add_td_basic( 'Your '.$this->board.' mySQL Information', 'left', 'catrow2' );
		
		//-----------------------------------------------------------------------------------------------------------
		
		$std->html .= $SKIN->add_td_row( array( "<b>Your {$this->board} mySQL <span style='color:red'>server location</span></b><br>This information is in your phpbb2/config.php file" ,
										  $SKIN->form_input( "hb_sql_host", $ibforums->vars['hb_sql_host'] )
								 )      );
									     
		$std->html .= $SKIN->add_td_row( array( "<b>Your {$this->board} mySQL <span style='color:red'>database name</span></b><br>This information is in your phpbb2/config.php file" ,
										  $SKIN->form_input( "hb_sql_database", $ibforums->vars['hb_sql_database'] == "" ? $_POST['hb_sql_database'] : $ibforums->vars['hb_sql_database'] )
								 )      );
 
		$std->html .= $SKIN->add_td_row( array( "<b>Your {$this->board} mySQL <span style='color:red'>database username</span></b><br>This information is in your phpbb2/config.php file" ,
										  $SKIN->form_input( "hb_sql_user", $ibforums->vars['hb_sql_user'] == "" ? $_POST['hb_sql_user'] : $ibforums->vars['hb_sql_user'] )
								 )      );
								 
		$std->html .= $SKIN->add_td_row( array( "<b>Your {$this->board} mySQL <span style='color:red'>database password</span></b><br>This information is in your phpbb2/config.php file" ,
										  $SKIN->form_input( "hb_sql_pass", $ibforums->vars['hb_sql_pass'] == "" ? $_POST['hb_sql_pass'] : $ibforums->vars['hb_sql_pass'], 'password' )
								 )      );
								 
		$std->html .= $SKIN->add_td_row( array( "<b>Your {$this->board} mySQL <span style='color:red'>table prefix</span></b><br>This information is in your phpbb2/config.php file" ,
										  $SKIN->form_input( "hb_sql_tbl_prefix", $ibforums->vars['hb_sql_tbl_prefix'] == "" ? $_POST['hb_sql_tbl_prefix'] : $ibforums->vars['hb_sql_tbl_prefix'] )
								 )      );
								 
		//-----------------------------------------------------------------------------------------------------------
		
		$std->html .= $SKIN->add_td_basic( 'Convertor Preferences', 'left', 'catrow2' );
		
		//-----------------------------------------------------------------------------------------------------------
		
		$std->html .= $SKIN->add_td_row( array( "<b>How many MEMBERS to convert per rotation?</b><br>Low CPU intensive, about 2000 is good for most" ,
										  $SKIN->form_input( "per_members", $ibforums->vars['per_members'] == "" ? $_POST['per_members'] : $ibforums->vars['per_members'] )
								 )      );
								 
		$std->html .= $SKIN->add_td_row( array( "<b>How many TOPICS / POLLS to convert per rotation?</b><br>Low CPU intensive, about 2000 is good for most" ,
										  $SKIN->form_input( "per_topics", $ibforums->vars['per_topics'] == "" ? $_POST['per_topics'] : $ibforums->vars['per_topics'] )
								 )      );
								 
		$std->html .= $SKIN->add_td_row( array( "<b>How many POSTS to convert per rotation?</b><br>Medium CPU intensive, about 1500 is good for most" ,
										  $SKIN->form_input( "per_posts", $ibforums->vars['per_posts'] == "" ? $_POST['per_posts'] : $ibforums->vars['per_posts'] )
								 )      );
		
		//-----------------------------------------------------------------------------------------------------------
		
		$std->html .= $SKIN->end_form('Save Configuration');
										 
		$std->html .= $SKIN->end_table();
		
		$std->output();
		
	}
	
	

	function get_host_rows()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums;
		
		// Get the number of users in the vB database
		
		$return = array();
		
		//-----------------------------------------------
		// Get the number of users in the vB database
		//-----------------------------------------------
		
		$HB->query("SELECT COUNT(*) as users FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."users");
		
		$a = $HB->fetch_row();
		
		$return['members'] = ( $a['users'] > 0 ) ? $a['users'] : 0;
		
		//-----------------------------------------------
		// Get number of Forums
		//-----------------------------------------------
		// vB forums are a little different.
		// We'll have to "guess" by choosing forums
		// from cats by 'cancontainthreads'
		
		$HB->query("SELECT COUNT(*) as forums FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."forums");
		
		$b = $HB->fetch_row();
		
		$return['forums'] = ( $b['forums'] > 0 ) ? $b['forums'] : 0;
		
		//-----------------------------------------------
		// Categories
		//-----------------------------------------------
		
		$HB->query("SELECT COUNT(*) as cats FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."categories");
		
		$c = $HB->fetch_row();
		
		$return['categories'] = ( $c['cats'] > 0 ) ? $c['cats'] : 0;
		
		//-----------------------------------------------
		// Member Groups
		//-----------------------------------------------
		
		$HB->query("SELECT COUNT(*) as groups FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."groups");
		
		$d = $HB->fetch_row();
		
		$return['groups'] = ( $d['groups'] > 0 ) ? $d['groups'] : 0;
		
		//-----------------------------------------------
		// Ranks
		//-----------------------------------------------
		
		$HB->query("SELECT COUNT(*) as ranks FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."ranks");
		
		$e = $HB->fetch_row();
		
		$return['ranks'] = ( $e['ranks'] > 0 ) ? $e['ranks'] : 0;
		
		//-----------------------------------------------
		// Topics
		//-----------------------------------------------
		
		$HB->query("SELECT COUNT(*) as threads FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."topics");
		
		$f = $HB->fetch_row();
		
		$return['topics'] = ( $f['threads'] > 0 ) ? $f['threads'] : 0;
		
		//-----------------------------------------------
		// Posts
		//-----------------------------------------------
		
		$HB->query("SELECT COUNT(*) as posts FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."posts");
		
		$g = $HB->fetch_row();
		
		$return['posts'] = ( $g['posts'] > 0 ) ? $g['posts'] : 0;
		
		//-----------------------------------------------
		// Personal Messages
		//-----------------------------------------------
		
		$HB->query("SELECT COUNT(*) as pms FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."privmsgs");
		
		$h = $HB->fetch_row();
		
		$return['pms'] = ( $h['pms'] > 0 ) ? $h['pms'] : 0;
		
		//-----------------------------------------------
		// Poll Voters
		//-----------------------------------------------
		
		$HB->query("SELECT COUNT(*) as polls FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."vote_desc");
		
		$i = $HB->fetch_row();
		
		$return['polls'] = ( $i['polls'] > 0 ) ? $i['polls'] : 0;
		
		//-----------------------------------------------
		// Moderators
		//-----------------------------------------------
		
		$HB->query("SELECT COUNT(*) as mods FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."auth_access where auth_mod=1");
		
		$j = $HB->fetch_row();
		
		$return['moderators'] = ( $j['mods'] > 0 ) ? $j['mods'] : 0;
		
		return $return;
		
	}

	//-----------------------------------------------------
	// Returns intro text, such as what can't be converted,
	// etc
	//-----------------------------------------------------

	function get_intro($tbl)
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums;
		
		if ($tbl == 'members')
		{
			return "<b>Converting Members</b><br><br>Due to the different ways that the information is stored, not all member information can be converted cleanly. Avatars may not be converted as well as
			some other member preferences. Member names, posts and passwords will be converted successfully.<br><br>As with all conversion sections, running the convertor will empty your Invision Power
			Board Members table before inserting the new data. It is suggested that you ensure that you know your administrators account password before converting. Due to the way that phpBB constructs the member
			group permissions, the groups will not be converted and the administrators will be put into the IPB admin group and all other members will be placed into the default member group.";
		}
		else if ($tbl == 'forums')
		{
			return "<b>Converting Forums</b><br><br>Due to the different forum access mask permissions, the forums will be converted to GLOBAL read permissions, meaning that all groups can read, write and reply
			into all your current forums regardless of the phpBB permissions system.
			<br><br>
			After converting the forums, your Invision Power Board will be set into Offline mode to protect your private forums until you've had a chance to reset the forum permissions.
			";
		}
		else if ($tbl == 'categories')
		{
			return "<b>Converting Categories</b><br><br>
			Due to the different ways categories are created, you may need to edit some information post-installation to ensure correct ordering";
		}
		else if ($tbl == 'groups')
		{
			return "<b>Converting Groups</b><br><br>
			Due to the different ways groups are used in phpBB member group conversion is not neeeded as it is automatically organised during the member conversion.";
		}
		else if ($tbl == 'ranks')
		{
			return "<b>Converting User Ranks</b><br><br>
			This will convert existing user rank tiers into the Invision Power Board Format. After conversion, you can edit these via the IPB Admin CP to enable to extra features IPB has.";
		}
		else if ($tbl == 'topics')
		{
			return "<b>Converting Topics</b><br><br>
			Topics that are just moved topics redirects will not be converted.";
		}
		else if ($tbl == 'posts')
		{
			return "<b>Converting Posts</b><br><br>
			If you are running the phpBB2 attachment modification, the attachments will not be converted.";
		}
		else if ($tbl == 'pms')
		{
			return "<b>Converting Personal Messages</b><br><br>
			Please note that custom messenger folders cannot be converted and all messages that are not in the inbox or sent items folder will not be converted.";
		}
		else if ($tbl == 'polls')
		{
			return "<b>Converting Polls</b><br><br>
			Please note that the poll voters will not be converted, allowing your members to vote again in an existing poll.";
		}
		else if ($tbl == 'moderators')
		{
			return "<b>Converting Moderators</b><br><br>
			You may need to edit the moderators post-installation to ensure that the extra features in IPB are activated.";
		}
	}

	//-----------------------------------------------------
	// Returns done text,
	//-----------------------------------------------------

	function get_end($tbl)
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums;
		
		if ($tbl == 'members')
		{
			return "<b>Members Converted</b><br><br>All members have been converted.<br>The existing username and password should be able to be used without any problems.<br><br>There may
			be instances where unusual user names containing HTML entities (such as &gt;, &lt;, etc) may have trouble logging in, if this is the case, a simple member name change from the
			IPB Admin CP will fix the problem.";
		}
		else if ( $tbl == 'forums' )
		{
			return "<b>Forums Converted</b><br><br>After you have converted all the sections, it is advised that you re-set the forum permissions and edit any sub forums to ensure the
			correct forum structure.";
		}
		else if ( $tbl == 'categories' )
		{
			return "<b>Categories Converted</b>";
		}
		else if ( $tbl == 'groups' )
		{
			return "<b>Member Groups Converted</b>";
		}
		else if ( $tbl == 'ranks' )
		{
			return "<b>User Ranks Converted</b>";
		}
		else if ( $tbl == 'topics' )
		{
			return "<b>Topics Converted</b>";
		}
		else if ( $tbl == 'posts' )
		{
			return "<b>Posts Converted</b>";
		}
		else if ( $tbl == 'pms' )
		{
			return "<b>Personal Messages Converted</b>";
		}
		else if ( $tbl == 'polls' )
		{
			return "<b>Polls Converted</b>";
		}
		else if ( $tbl == 'moderators' )
		{
			return "<b>Moderators Converted</b>";
		}
	}
	
	
	//-----------------------------------------------------
	// Returns intro text, such as what can't be converted,
	// etc
	//-----------------------------------------------------

	function convert($tbl)
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums;
		
		switch($tbl)
		{
			case 'members':
				$this->_convert_members();
				break;
			case 'forums':
				$this->_convert_forums();
				break;
			case 'categories':
				$this->_convert_categories();
				break;
			case 'groups':
				$this->_convert_groups();
				break;
			case 'ranks':
				$this->_convert_ranks();
				break;
			case 'topics':
				$this->_convert_topics();
				break;
			case 'posts':
				$this->_convert_posts();
				break;
			case 'pms':
				$this->_convert_pms();
				break;
			case 'polls':
				$this->_convert_polls();
				break;
			case 'moderators':
				$this->_convert_moderators();
				break;
		}
	}
	
	
	//====================================================================
	//
	// CONVERT MODERATORS
	//
	//====================================================================

	function _convert_moderators()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		
		//---------------------------
		// Did you drop one?
		//---------------------------
		
		if ( intval($ibforums->input['drop']) == 1 )
		{
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}moderators");
		}
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$HB->query("SELECT m.*, mem.username
					  FROM ".$ibforums->vars['hb_sql_database'].".moderator m, ".$ibforums->vars['hb_sql_database'].".user mem
					WHERE m.userid=mem.userid");
					
		if ( ! $HB->get_num_rows() )
		{
			// We are done?
			$std->redirect_screen("Moderator conversion complete", "?a=convert&tbl=moderators&end=1");
		}
		
		while ( $row = $HB->fetch_row() )
		{
			$db_string = "";
			
			if ( $row['moderatorid'] == "" OR $row['userid'] == "" OR $row['forumid'] == "")
			{
				continue;
			}
			
			$db_array = array(
								'mid'		  => $row['moderatorid'],
								'forum_id'	  => $row['forumid'],
								'member_name' => $row['username'],
								'member_id'	  => $row['userid'],
								'edit_post'	  => $row['caneditposts'],
								'edit_topic'  => $row['caneditthreads'],
								'delete_post' => $row['candeleteposts'],
								'delete_topic'=> $row['canmanagethreads'],
								'view_ip'	  => $row['canviewips'],
								'open_topic'  => $row['canopenclose'],
								'close_topic' => $row['canopenclose'],
								'mass_move'   => $row['canmassmove'],
								'mass_prune'  => $row['canmassprune'],
								'move_topic'  => $row['canmanagethreads'],
								'pin_topic'   => $row['canmanagethreads'],
								'unpin_topic' => $row['canmanagethreads'],
								'post_q'      => $row['canmoderateposts'],
								'topic_q'     => $row['canmoderateposts'],
								'allow_warn'  => 0,
								'edit_user'   => $row['canviewprofile'],
								'is_group'    => 0,
								'split_merge' => $row['canmanagethreads'],
							);

			$db_string = $DB->compile_db_insert_string($db_array);
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}moderators (".$db_string['FIELD_NAMES'].") VALUES(".$db_string['FIELD_VALUES'].")");
	
		}
		
		$std->redirect_screen("Moderators conversion complete", "?a=convert&tbl=moderators&end=1");
		
	}
	
	
	
	//====================================================================
	//
	// CONVERT POLLS
	//
	//====================================================================

	function _convert_polls()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		//---------------------------
		// Limit rows
		//---------------------------
		
		$end   = (intval($ibforums->vars['per_topics']) > 0) ? intval($ibforums->vars['per_topics']) : 50000;
		$start =      (intval($ibforums->input['st']) > 0)    ?      intval($ibforums->input['st'])    : 0;
		
		//---------------------------
		// Did you drop one?
		//---------------------------
		
		if ( intval($ibforums->input['drop']) == 1 )
		{
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}polls");
		}
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$phpbb_tbl = $ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix'];
		
		$oq = $HB->query("SELECT vd.*, t.topic_poster, t.forum_id FROM {$phpbb_tbl}vote_desc vd
							  LEFT JOIN {$phpbb_tbl}topics t ON vd.topic_id=t.topic_id
						  LIMIT $start, $end");
					
		if ( ! $HB->get_num_rows($oq) )
		{
			// We are done?
			$std->redirect_screen("Poll conversion complete", "?a=convert&tbl=polls&end=1");
		}
		
		while ( $row = $HB->fetch_row($oq) )
		{
			$db_string = "";
			
			if ( $row['vote_id'] == "" )
			{
				continue;
			}
			
			$nq = $HB->query("SELECT * FROM {$phpbb_tbl}vote_results WHERE vote_id=".$row['vote_id']);
			
			$t_votes    = 0;
			$poll_array = array();
			
			while ($r = $DB->fetch_row($nq))
			{
				$id        = $r['vote_option_id'];
				$option    = str_replace( "'", "&#39;", $r['vote_option_text']);
				$total     = $r['vote_result'];
				
				$poll_array[$id] = array($id , $option, $total);
				
				$t_votes += $total;
			} 
			
			//---------------
			
			$db_array = array(
								'pid'		=> $row['vote_id'],
								'tid'		=> $row['topic_id'],
								'start_date'=> $row['vote_start'],
								'choices'   => addslashes(serialize($poll_array)),
								'starter_id'=> $row['topic_poster'],
								'votes'     => $total_votes,
								'forum_id'  => $row['forum_id'],
								'poll_question' => $std->txt_safeslashes($row['vote_text'])
							);
							
			$db_string = $DB->compile_db_insert_string($db_array);
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}polls (".$db_string['FIELD_NAMES'].") VALUES(".$db_string['FIELD_VALUES'].")");
	
		}
		
		// Done?
		// Ok - redirect for the next batch
		
		$new_start = $start + $end;
		
		$std->redirect_screen("Polls $start to $new_start converted....", "?a=convert&tbl=polls&st=$new_start");
		
	}
	
	//====================================================================
	//
	// CONVERT PRIVATE MESSAGES
	//
	//====================================================================

	function _convert_pms()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		//---------------------------
		// Limit rows
		//---------------------------
		
		$end   = (intval($ibforums->vars['per_posts']) > 0) ? intval($ibforums->vars['per_posts']) : 50000;
		$start =      (intval($ibforums->input['st']) > 0)    ?      intval($ibforums->input['st'])    : 0;
		
		//---------------------------
		// Did you drop one?
		//---------------------------
		
		if ( intval($ibforums->input['drop']) == 1 )
		{
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}messages");
		}
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$phpbb_tbl = $ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix'];
		
		$HB->query("SELECT pm.*, pmt.* FROM {$phpbb_tbl}privmsgs pm, {$phpbb_tbl}privmsgs_text pmt WHERE pm.privmsgs_id=pmt.privmsgs_text_id LIMIT $start, $end");
					
		if ( ! $HB->get_num_rows() )
		{
			// We are done?
			$std->redirect_screen("Personal message conversion complete", "?a=convert&tbl=pms&end=1");
		}
		
		while ( $row = $HB->fetch_row() )
		{
			$db_string = "";
			
			if ( $row['privmsgs_id'] == "" OR $row['privmsgs_subject'] == "" OR $row['privmsgs_type'] >= 3)
			{
				continue;
			}
			
			// privmsgs_type ( 0: Read, 1: Unread, 2: Sent, 3: Saved_in, 4: Saved_Out )
			
			if ( $row['privmsgs_type'] > 1 )
			{
				// Sent items folder
			
				$db_array = array(
									'msg_id'		=> $row['privatemessageid'],
									'msg_date'	    => $row['privmsgs_date'],
									'read_state'	=> 1,
									'title'			=> $row['privmsgs_subject'],
									'message'		=> $PARSER->convert( array( 'TEXT'      => $this->unconvert_bbcode($std->txt_safeslashes($row['privmsgs_text'])),
																				'SMILIES'   => 1,
																				'CODE'      => 1,
																				'HTML'      => 0,
																				'SIGNATURE' => 0
																	   )       ),
									'from_id'		=> $row['privmsgs_from_userid'],
									'vid'			=> 'sent',
									'member_id'		=> $row['privmsgs_from_userid'],
									'recipient_id'	=> $row['privmsgs_to_userid'],
								);
			}
			else
			{
				// Inbox (read / unread)
				
				$db_array = array(
									'msg_id'		=> $row['privatemessageid'],
									'msg_date'	    => $row['privmsgs_date'],
									'read_state'	=> $row['privmsgs_type'] == 1 ? 1 : 0,
									'title'			=> $std->txt_safeslashes($row['privmsgs_subject']),
									'message'		=> $PARSER->convert( array( 'TEXT'      => $this->unconvert_bbcode($std->txt_safeslashes($row['privmsgs_text'])),
																				'SMILIES'   => 1,
																				'CODE'      => 1,
																				'HTML'      => 0,
																				'SIGNATURE' => 0
																	   )       ),
									'from_id'		=> $row['privmsgs_from_userid'],
									'vid'			=> 'in',
									'member_id'		=> $row['privmsgs_to_userid'],
									'recipient_id'	=> $row['privmsgs_to_userid'],
								);
				
			}


			$db_string = $DB->compile_db_insert_string($db_array);
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}messages (".$db_string['FIELD_NAMES'].") VALUES(".$db_string['FIELD_VALUES'].")");
	
		}
		
		// Done?
		// Ok - redirect for the next batch
		
		$new_start = $start + $end;
		
		$std->redirect_screen("Personal Messages $start to $new_start converted....", "?a=convert&tbl=pms&st=$new_start");
		
	}
	
	//====================================================================
	//
	// CONVERT POSTS
	//
	//====================================================================

	function _convert_posts()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		//---------------------------
		// Limit rows
		//---------------------------
		
		$end   = (intval($ibforums->vars['per_posts']) > 0) ? intval($ibforums->vars['per_posts']) : 50000;
		$start =      (intval($ibforums->input['st']) > 0)    ?      intval($ibforums->input['st'])    : 0;
		
		//---------------------------
		// Did you drop one?
		//---------------------------
		
		if ( intval($ibforums->input['drop']) == 1 )
		{
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}posts");
		}
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$phpbb_tbl = $ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix'];
		
		$HB->query("SELECT p.*, pt.*, u.username, u.user_id FROM {$phpbb_tbl}posts p
					 LEFT JOIN {$phpbb_tbl}posts_text pt ON pt.post_id=p.post_id
					 LEFT JOIN {$phpbb_tbl}users u ON p.poster_id=u.user_id
					ORDER BY p.post_id ASC
				    LIMIT $start, $end");
					
		if ( ! $HB->get_num_rows() )
		{
			// We are done?
			$std->redirect_screen("Post conversion complete", "?a=convert&tbl=posts&end=1");
		}
		
		while ( $row = $HB->fetch_row() )
		{
			$db_string = "";
			
			if ( $row['post_id'] == "" )
			{
				continue;
			}
			
			$db_array = array(
								'pid'		  => $row['post_id'],
								'author_id'   => $row['user_id'],
								'author_name' => $row['username'] ? $std->txt_safeslashes($row['username']) : $std->txt_safeslashes($row['post_username']),
								'use_sig'     => $row['enable_sig'],
								'use_emo'     => $row['enable_smilies'],
								'ip_address'  => $this->convert_ip($row['poster_ip']),
								'post_date'   => $row['post_time'],
								'icon_id'	  => 0,
								'post'		  => $PARSER->convert( array( 'TEXT'      => $this->unconvert_bbcode($std->txt_safeslashes($row['post_text'])),
																   		  'SMILIES'   => $row['enable_smilies'],
																   		  'CODE'      => 1,
																   		  'HTML'      => 0,
																  		  'SIGNATURE' => 0
														 		)       ),
								'queued'      => 0,
								'topic_id'    => $row['topic_id'],
								'forum_id'    => $row['forum_id'],
								'post_title'  => $std->txt_safeslashes($row['post_subject']),
								'new_topic'   => 0
							);
							
			$db_string = $DB->compile_db_insert_string($db_array);
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}posts (".$db_string['FIELD_NAMES'].") VALUES(".$db_string['FIELD_VALUES'].")");
	
		}
		
		// Done?
		// Ok - redirect for the next batch
		
		$new_start = $start + $end;
		
		$std->redirect_screen("Posts $start to $new_start converted....", "?a=convert&tbl=posts&st=$new_start");
		
	}
	
	//====================================================================
	//
	// CONVERT TOPICS
	//
	//====================================================================

	function _convert_topics()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		//---------------------------
		// Limit rows
		//---------------------------
		
		$end   = (intval($ibforums->vars['per_topics']) > 0) ? intval($ibforums->vars['per_topics']) : 50000;
		$start =      (intval($ibforums->input['st']) > 0)    ?      intval($ibforums->input['st'])    : 0;
		
		//---------------------------
		// Did you drop one?
		//---------------------------
		
		if ( intval($ibforums->input['drop']) == 1 )
		{
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}topics");
		}
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$phpbb_tbl = $ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix'];
		
		$mq = $HB->query("SELECT t.*, p.poster_id, p.post_time, u.username FROM {$phpbb_tbl}topics t
							LEFT JOIN {$phpbb_tbl}posts p ON t.topic_last_post_id=p.post_id
							LEFT JOIN {$phpbb_tbl}users u ON t.topic_poster=u.user_id
						  LIMIT $start, $end");
					
		if ( ! $HB->get_num_rows($mq) )
		{
			// We are done?
			$std->redirect_screen("Topic conversion complete", "?a=convert&tbl=topics&end=1");
		}
		
		while ( $row = $HB->fetch_row($mq) )
		{
			$db_string = "";
			
			if ( $row['topic_id'] == "" OR $row['topic_title'] == "" OR $row['topic_moved_id'] > 0 )
			{
				continue;
			}
			
			// Stupid phpBB...
			
			if ( $row['poster_id'] )
			{
				$nq = $HB->query("SELECT username, user_id FROM {$phpbb_tbl}users WHERE user_id=".$row['poster_id']);
				
				$last_poster = $HB->fetch_row($nq);
			}
			
			$db_array = array(
								'tid'		       => $row['topic_id'],
								'title'		       => $std->txt_safeslashes($row['topic_title']),
								'state'		       => $row['topic_status'] == 0 ? 'open' : 'closed',
								'posts'		       => $row['topic_replies'],
								'starter_id'       => $row['topic_poster'],
								'starter_name'     => $std->txt_safeslashes($row['username']),
								'start_date'       => $row['topic_time'],
								'last_post'        => $row['post_time'],
								'icon_id'          => 0,
								'last_poster_id'   => $last_poster['user_id'],
								'last_poster_name' => $std->txt_safeslashes($last_poster['username']),
								'poll_state'	   => $row['topic_vote'] > 0 ? 'open' : 0,
								'last_vote'		   => 0,
								'views'			   => $row['topic_views'],
								'forum_id'		   => $row['forum_id'],
								'approved'		   => 1,
								'author_mode'	   => 1,
								'pinned'		   => $row['topic_type'] == 0 ? 0 : 1
								
								
							);

							
			$db_string = $DB->compile_db_insert_string($db_array);
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}topics (".$db_string['FIELD_NAMES'].") VALUES(".$db_string['FIELD_VALUES'].")");
	
		}
		
		// Done?
		// Ok - redirect for the next batch
		
		$new_start = $start + $end;
		
		$std->redirect_screen("Topics $start to $new_start converted....", "?a=convert&tbl=topics&st=$new_start");
		
	}
	
	//====================================================================
	//
	// CONVERT RANKS
	//
	//====================================================================

	function _convert_ranks()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		
		//---------------------------
		// Did you drop one?
		//---------------------------
		
		if ( intval($ibforums->input['drop']) == 1 )
		{
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}titles");
		}
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$HB->query("SELECT * FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."ranks");
					
		if ( ! $HB->get_num_rows() )
		{
			// We are done?
			$std->redirect_screen("User Rank conversion complete", "?a=convert&tbl=ranks&end=1");
		}
		
		while ( $row = $HB->fetch_row() )
		{
			$db_string = "";
			
			$db_array = array(
								'id'	=> $row['rank_id'],
								'posts' => $row['rank_min'],
								'title' => $std->txt_safeslashes($row['rank_title']),
							);

			$db_string = $DB->compile_db_insert_string($db_array);
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}titles (".$db_string['FIELD_NAMES'].") VALUES(".$db_string['FIELD_VALUES'].")");
	
		}
		
		$std->redirect_screen("User Ranks conversion complete", "?a=convert&tbl=ranks&end=1");
		
	}
	
	
	//====================================================================
	//
	// CONVERT GROUPS
	//
	//====================================================================

	function _convert_groups()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		
		//---------------------------
		// Did you drop one?
		//---------------------------
		
		if ( intval($ibforums->input['drop']) == 1 )
		{
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}groups");
		}
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$HB->query("SELECT * FROM ".$ibforums->vars['hb_sql_database'].".usergroup");
					
		if ( ! $HB->get_num_rows() )
		{
			// We are done?
			$std->redirect_screen("Member Group conversion complete", "?a=convert&tbl=groups&end=1");
		}
		
		while ( $row = $HB->fetch_row() )
		{
			$db_string = "";
			
			$view_offline = ($row['usergroupid'] == 6) ? 1 : 0;
			
			$db_array = array(
								'g_id'			     => $row['usergroupid'],
								'g_view_board'	     => $row['canview'],
								'g_mem_info'	     => $row['canviewmembers'],
								'g_other_topics'     => $row['canviewothers'],
								'g_use_search'	     => $row['cansearch'],
								'g_email_friend'     => 1,
								'g_invite_friend'    => 1,
								'g_edit_profile'     => $row['canmodifyprofile'],
								'g_post_new_topics'  => $row['canpostnew'],
								'g_reply_own_topics' => $row['canreplyothers'],
								'g_edit_posts'		 => $row['caneditpost'],
								'g_delete_own_posts' => $row['candeletepost'],
								'g_open_close_posts' => $row['canopenclose'],
								'g_delete_own_topics'=> $row['candeletethread'],
								'g_post_polls'		 => $row['canpostpoll'],
								'g_vote_polls'		 => $row['canvote'],
								'g_use_pm'			 => $row['canusepm'],
								'g_is_supmod'		 => $row['ismoderator'],
								'g_access_cp'		 => $row['cancontrolpanel'],
								'g_title'			 => $std->txt_safeslashes($row['title']),
								'g_can_remove'		 => 0,
								'g_append_edit'      => 1,
								'g_access_offline'   => $view_offline,
								'g_avoid_q'			 => $row['ismoderator'],
								'g_avoid_flood'		 => $row['ismoderator'],
								'g_calendar_post'	 => $row['canpublicevent'],
								
							);

			$db_string = $DB->compile_db_insert_string($db_array);
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}groups (".$db_string['FIELD_NAMES'].") VALUES(".$db_string['FIELD_VALUES'].")");
	
		}
		
		// Change default group stuff
		// 1 => guest group (2)
		// 3 => Authorizing (1)
		// 2 => Registered Members (3)
		// 6 => Root Admins (4)
		/*$INFO['admin_group']			=	'4';
		$INFO['auth_group']			=	'1';
		$INFO['member_group']			=	'3';
		$INFO['guest_group']			=	'2';*/
		
		$std->rebuild_config( array( 
									 'admin_group'  => 6,
									 'auth_group'   => 3,
									 'member_group' => 2,
									 'guest_group'  => 1
							)      );
		
		$std->redirect_screen("Member Group conversion complete", "?a=convert&tbl=groups&end=1");
		
	}
	
	//====================================================================
	//
	// CONVERT CATEGORIES
	//
	//====================================================================

	function _convert_categories()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		
		//---------------------------
		// Did you drop one?
		//---------------------------
		
		if ( intval($ibforums->input['drop']) == 1 )
		{
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}categories");
		}
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$HB->query("SELECT * FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."categories");
					
		if ( ! $HB->get_num_rows() )
		{
			// We are done?
			$std->redirect_screen("Category conversion complete", "?a=convert&tbl=categories&end=1");
		}
		
		while ( $row = $HB->fetch_row() )
		{
			$db_string = "";
			
			$db_array = array(
								'id'		  => $row['cat_id'],
								'position'    => $row['cat_order'],
								'state'		  => 1,
								'name'		  => $row['cat_title'],
							);
							
							
			$db_string = $DB->compile_db_insert_string($db_array);
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}categories (".$db_string['FIELD_NAMES'].") VALUES(".$db_string['FIELD_VALUES'].")");
	
		}
		
		$std->redirect_screen("Category conversion complete", "?a=convert&tbl=categories&end=1");
		
	}
	
	//====================================================================
	//
	// CONVERT FORUMS
	//
	//====================================================================

	function _convert_forums()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		
		//---------------------------
		// Did you drop one?
		//---------------------------
		
		if ( intval($ibforums->input['drop']) == 1 )
		{
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}forums");
		}
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$HB->query("SELECT * FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."forums");
					
		if ( ! $HB->get_num_rows() )
		{
			// We are done?
			$std->redirect_screen("Forums conversion complete", "?a=convert&tbl=forums&end=1");
		}
		
		while ( $row = $HB->fetch_row() )
		{
			$db_string = "";
			
			$db_array = array(
								'id'               => $row['forum_id'],
								'topics'           => $row['forum_topics'],
								'posts'            => $row['forum_posts'],
								'last_post'        => 0,
								'last_poster_id'   => 1,
								'last_poster_name' => "",
								'name'             => $std->txt_safeslashes($row['forum_name']),
								'description'      => $std->txt_safeslashes($row['forum_desc']),
								'position'		   => $row['forum_order'],
								'use_ibc'          => 1,
								'use_html'         => 0,
								'status'           => $row['forum_status'] ? 0 : 1,
								'reply_perms'      => '*',
								'start_perms'      => '*',
								'read_perms'       => '*',
								'category'         => $row['cat_id'],
								'sort_key'         => 'last_post',
								'sort_order'       => 'Z-A',
								'prune'            => 30,
								'preview_posts'    => 0,
								'allow_poll'       => 1,
								'allow_pollbump'   => 0,
								'inc_postcount'    => 1,
							);
							
			$db_string = $DB->compile_db_insert_string($db_array);
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}forums (".$db_string['FIELD_NAMES'].") VALUES(".$db_string['FIELD_VALUES'].")");
	
		}
		
		// Turn board offline.
		
		$std->rebuild_config( array( 
										'offline_msg'       =>  "<b>Welcome!</b><br><br>We are in the process of upgrading our forums, please try again later!
															    <br><br>If you are the board administrator, you can log in below and begin setting up your new board",
										'board_offline'		=>  1,
						    )      );
		
		$std->redirect_screen("Forums conversion complete", "?a=convert&tbl=forums&end=1");
		
	}
	
	//====================================================================
	//
	// CONVERT MEMBERS
	//
	//====================================================================

	function _convert_members()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		//---------------------------
		// Limit rows
		//---------------------------
		
		$end   = (intval($ibforums->vars['per_members']) > 0) ? intval($ibforums->vars['per_members']) : 50000;
		$start =      (intval($ibforums->input['st']) > 0)    ?      intval($ibforums->input['st'])    : 0;
		
		//---------------------------
		// Did you drop one?
		//---------------------------
		
		if ( intval($ibforums->input['drop']) == 1 )
		{
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}members");
			$DB->query("DELETE FROM ".$ibforums->vars['sql_database'].".{tbl.prefix}pfields_content");
			
			// Add back in the guest member for IPB:
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}members (id, name, mgroup, password, email, joined, ip_address, avatar, avatar_size, posts, aim_name,
			 			icq_number, location, signature, website, yahoo, title, allow_admin_mails, time_offset, interests, hide_email,
			 			email_pm, email_full, skin, warn_level, language, msnname, last_post, view_sigs, view_img, view_avs,
			 			view_pop, bday_day, bday_month, bday_year, new_msg, msg_from_id, msg_msg_id, msg_total, vdirs, show_popup,
			 		    misc, last_visit, last_activity, dst_in_use, view_prefs,
			 			auto_track) VALUES (0, 'Guest', 2, '', 'guest@guest.com', 0, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL,
			 			NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, 1, 1, 1, 0,
			 			0, 0, NULL, NULL, NULL, NULL, NULL, NULL, '0', 0, 0, 0, '-1&-1', 0)");

		}
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$HB->query("SELECT * FROM ".$ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix']."users
				    WHERE username <> 'Anonymous'
					LIMIT $start, $end");
					
		if ( ! $HB->get_num_rows() )
		{
			// We are done?
			$std->redirect_screen("Member conversion complete", "?a=convert&tbl=members&end=1");
		}
		
		while ( $row = $HB->fetch_row() )
		{
			$db_string = "";
			
			if ( $row['user_id'] == "" OR $row['username'] == "" OR $row['user_password'] == "" )
			{
				continue;
			}
			
			$group = ( $row['user_level'] == 1 ) ? 4 : 3;
			
			if ($row["user_avatar"] != "")
			{
    			if ( preg_match("!http://!", $row["user_avatar"]) )
    			{
        			$avatar = $row["user_avatar"];
    			}
    			else
        		{
        			$avatar_arry = explode("/", $row["user_avatar"]);
       				$avatar = $avatar_arry[count($avatar_arry) - 1];
         		} 
			}
			else
			{
				$avatar = "noavatar";
			} 

			$time_arry = explode( ".", $row['user_timezone']);
			$time_offset  = $time_arry[0];
			
			$db_array = array(
								'id'         => $row['user_id'],
								'name'       => $std->txt_safeslashes($row['username']),
								'mgroup'     => $group,
								'password'   => $row['user_password'],
								'avatar'     => $avatar,
								'email'      => $row['user_email'],
								'joined'     => $row['user_regdate'],
								'ip_address' => '127.0.0.1',
								'posts'      => $row['user_posts'],
								'aim_name'   => $std->txt_safeslashes($row['user_aim']),
								'icq_number' => $std->txt_safeslashes($row['user_icq']),
								'location'   => $std->txt_safeslashes($row['user_from']),
								'signature'  => $PARSER->convert( array( 'TEXT'      => $this->unconvert_bbcode($std->txt_safeslashes($row['user_sig'])),
																   		 'SMILIES'   => 0,
																   		 'CODE'      => $ibforums->vars['sig_allow_ibc'],
																   		 'HTML'      => $ibforums->vars['sig_allow_html'],
																  		 'SIGNATURE' => 1
														 		)       ),
								'website'	 => $std->txt_safeslashes($row['user_website']),
								'yahoo'      => $std->txt_safeslashes($row['user_yim']),
								'allow_admin_mails' => 0,
								'time_offset'=> $time_offset,
								'interests'  => $std->txt_safeslashes($row['user_interests']),
								'hide_email' => $row['user_viewmail'] ? 0 : 1,
								'language'   => 'en',
								'msnname'    => $std->txt_safeslashes($row['user_msnm']),
								'last_post'  => 0,
								'last_visit' => $row['user_lastvisit'],
								'last_activity' => $row['user_lastvisit'],
								'vdirs'         => "in:Inbox|sent:Sent Items",
								'email_pm'      => $row['user_notify_pm'],
							);
							
			$db_string = $DB->compile_db_insert_string($db_array);
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}members (".$db_string['FIELD_NAMES'].") VALUES(".$db_string['FIELD_VALUES'].")");
			
			$DB->query("INSERT INTO ".$ibforums->vars['sql_database'].".{tbl.prefix}pfields_content (member_id) VALUES(".$row['user_id'].")");
		}
		
		// Done?
		// Ok - redirect for the next batch
		
		$new_start = $start + $end;
		
		$std->redirect_screen("Members $start to $new_start converted....", "?a=convert&tbl=members&st=$new_start");
		
	}


	//====================================================================
	//
	// CONVERT PREFS
	//
	//====================================================================

	function _convert_prefs()
	{
		global $DB, $HB, $std, $SKIN, $IN, $INFO, $ibforums, $PARSER;
		
		//---------------------------
		// Convert...
		//---------------------------
		
		$phpbb_tbl = $ibforums->vars['hb_sql_database'].".".$ibforums->vars['hb_sql_tbl_prefix'];
		
		$HB->query("SELECT * FROM {$phpbb_tbl}config");
					
		while ( $row = $HB->fetch_row() )
		{
			$setting[ $row['config_name'] ] = $row['config_value'];
		}
		
		$std->rebuild_config( array( 
										'board_name'		=>  $std->clean_value($setting['sitename']),
										'email_in'			=>  $setting['board_email'],
										'email_out'			=>	$setting['board_email'],
										'sig_allow_ibc'		=>	$setting['allow_bbcode'],
										'display_max_posts' =>  $setting['posts_per_page'],
										'display_max_topics'=>  $setting['topics_per_page'],
										'disable_gzip'		=>  $setting['gzip_compress'] ? 0 : 1,
						    )      );

		
		$std->redirect_screen("Preferences Converted", "");
		
	}
	
	
	
	//============ OTHER FUNCTIONS ===================//
	
	function convert_ip($ip)
	{
    	$hexipbang = explode(".", chunk_split($ip, 2, "."));
    	return hexdec($hexipbang[0]) . "." . hexdec($hexipbang[1]) . "." . hexdec($hexipbang[2]) . "." . hexdec($hexipbang[3]);
	} 

	function unconvert_bbcode($text)
	{
		$text = preg_replace("/\[list(.+)]/i"                         , "[list]"   , $text);
		$text = preg_replace("/\[\*:([0-9|a-z]+)]/i"                  , "[*]"      , $text);
		$text = preg_replace("/\[\/list(.+)]/i"                       , "[list]"   , $text);
		$text = preg_replace("/\[color=(\#[0-9A-F]{6}|[a-z]+):([0-9|a-z]+)]/i", "[color=\\1]", $text);
		$text = preg_replace("/\[\/color(.+)]/i"                      , "[/color]", $text);
		$text = preg_replace("/\[size=([\-\+]?[1-2]?[0-9]):([0-9|a-z]+)]/si", "[size=\\1]", $text);
		$text = preg_replace("/\[\/size:([0-9|a-z]+)]/i"              , "[/size]" , $text);
		$text = preg_replace("/\[quote:(.*?)]/si"                     , "[quote]"  , $text);
		$text = preg_replace("/\[\/quote:(.*?)]/si"                   , "[/quote]" , $text);
		$text = preg_replace("/\[code:([0-9|a-z]+):([0-9|a-z]+)]/si"  , "[CODE]"   , $text);
		$text = preg_replace("/\[\/code:([0-9|a-z]+):([0-9|a-z]+)]/si", "[/CODE]"  , $text);
		$text = preg_replace("/\[b:([0-9|a-z]+)]/si"                  , "[b]"      , $text);
		$text = preg_replace("/\[\/b:([0-9|a-z]+)]/si"                , "[/b]"     , $text);
		$text = preg_replace("/\[u:([0-9|a-z]+)]/si"                  , "[u]"      , $text);
		$text = preg_replace("/\[\/u:([0-9|a-z]+)]/si"                , "[/u]"     , $text);
		$text = preg_replace("/\[i:([0-9|a-z]+)]/si"                  , "[i]"      , $text);
		$text = preg_replace("/\[\/i:([0-9|a-z]+)]/si"                , "[/i]"     , $text);
		$text = preg_replace("/\[img:(.*?)]/si"                       , "[IMG]"    , $text);
		$text = preg_replace("/\[\/img:(.*?)]/si"                     , "[/IMG]"   , $text);
		
		return $text;
	} 






}



?>